﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;

/// @author  Vesa Lappalainen
/// @version 06.10.2013
/// <summary>
/// Luodaan monta palloa peliin
/// </summary>
public class MontaPalloa : PhysicsGame
{
    /// <summary>
    /// Luodaan pallot yms.
    /// </summary>
    public override void Begin()
    {
        Level.Size = Screen.Size;
        Level.CreateBorders();
        BoundingRectangle alue = Level.BoundingRect;


        for (int i = 0; i < 10; i++)
        {
            LuoPallo(this,alue);
        }

        // Tapaus 
        //   for (int i = 0; i<3; i++) LuoPallo(this,alue)
        // i=0 -> eka pallo
        // i=1 -> toka pallo
        // i=2 -> kolmas pallo
        // i=3 -> eipä enää tehäkkää palloja
        /*
        int i = 0;

        while (i<100)
        {
            LuoPallo(this,alue);
            i++;
        }
        */
    }


    /// <summary>
    /// Aliohjelma tekee 3-10 -säteisen pallon 
    /// satunnaiseen paikkaan ruudulla.
    /// Pallo on myös satunnaisen värinen.
    /// </summary>
    /// <param name="peli">Mihin lisätään</param>
    /// <param name="alue">Alue josta x:n ja y:n arvonnan rajat</param>
    /// <returns>Luodun pallon viite</returns>
    public static PhysicsObject LuoPallo(GameObjectContainer peli, BoundingRectangle alue)
    {
        int sade = RandomGen.NextInt(3, 10);
        Vector paikka = RandomGen.NextVector(alue, sade);
        Color vari = RandomGen.NextColor();
        return LuoPallo(peli, paikka.X, paikka.Y, sade, vari);
    }


    /// <summary>
    /// Aliohjelma tekee ruudulle yhden pallon.
    /// </summary>
    /// <param name="peli">Mihin lisätään</param>
    /// <param name="x">Pallon x</param>
    /// <param name="y">Pallon y</param>
    /// <param name="sade">Pallon säde</param>
    /// <param name="vari">Pallon väri</param>
    /// <returns>Luodun pallon viite</returns>
    public static PhysicsObject LuoPallo(GameObjectContainer peli, double x, double y, double sade, Color vari)
    {
        PhysicsObject pallo = new PhysicsObject(sade*2, sade*2, Shape.Circle);
        pallo.X = x;
        pallo.Y = y;
        pallo.Color = vari;
        peli.Add(pallo);
        return pallo;
    }
}
